commit:     ba88569985ba83cd2fd5035028ee599fca26f622
Author:     Lars Wendler <polynomial-c <AT> gentoo <DOT> org>
AuthorDate: Tue Aug  1 07:45:50 2017 +0000
Commit:     Lars Wendler <polynomial-c <AT> gentoo <DOT> org>
CommitDate: Tue Aug  1 07:46:05 2017 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=ba885699

net-misc/dhcp: Bump to version 4.3.6

Package-Manager: Portage-2.3.6, Repoman-2.3.3
Signed-off-by: Lars Wendler <polynomial-c <AT> gentoo.org>

 net-misc/dhcp/Manifest                             |   1 +
 net-misc/dhcp/dhcp-4.3.6.ebuild                    | 262 +++++++++++++
 net-misc/dhcp/files/dhcp-3.0-fix-perms.patch       |   4 +-
 .../dhcp/files/dhcp-3.0.3-dhclient-no-down.patch   |   4 +-
 net-misc/dhcp/files/dhcp-4.3.6-dhclient-ntp.patch  | 210 ++++++++++
 .../files/dhcp-4.3.6-dhclient-resolvconf.patch     | 422 +++++++++++++++++++++
 net-misc/dhcp/files/dhcp-4.3.6-iproute2-path.patch |  11 +
 net-misc/dhcp/files/dhcp-4.3.6-nogateway.patch     |  66 ++++
 net-misc/dhcp/files/dhcp-4.3.6-quieter-ping.patch  |  66 ++++
 9 files changed, 1042 insertions(+), 4 deletions(-)

diff --git a/net-misc/dhcp/Manifest b/net-misc/dhcp/Manifest
index 3341a295d95..075efb60c20 100644
--- a/net-misc/dhcp/Manifest
+++ b/net-misc/dhcp/Manifest
@@ -1,2 +1,3 @@
 DIST dhcp-4.3.4.tar.gz 9302513 SHA256 
f5115aee3dd3e6925de4ba47b80ab732ba48b481c8364b6ebade2d43698d607e SHA512 
411c3f0e1effedb2a95f00539d13164530a56b50830008eb78906b3c8bf4070c331cf54a431770aed5d1b6ba214840446964210060674f746781cc97842ad706
 WHIRLPOOL 
ea283592268c8efabd7fec430bd21c45306822b9275c91ee1e604d09e92f9eb3c50941ea11ecd9dcb230caec3b8e6ee94958e8eb6375e0ca0e7a64a8aaf63bce
 DIST dhcp-4.3.5.tar.gz 10075147 SHA256 
eb95936bf15d2393c55dd505bc527d1d4408289cec5a9fa8abb99f7577e7f954 SHA512 
aba0e1d361eb9e7ed33fc48c0b0b9288057af9ec51775e40e27feb9ababc182506706fcf39079236ce36b0f7ded391e107474dc29de2e60ed45d37753505e1f0
 WHIRLPOOL 
85012016d81efb7654ec417e7a0f1a6145e8e143b13d6d9470d0fb7caf37c035441d5b2b8849d332f8ad0a9a6509bb0b931ac8f207f7ba9104e96811c0360124
+DIST dhcp-4.3.6.tar.gz 10182593 SHA256 
a41eaf6364f1377fe065d35671d9cf82bbbc8f21207819b2b9f33f652aec6f1b SHA512 
de4962dc2aa174df17a3a1456719a777a42d238c3d6ad1771ccc460fa70c9e9cefcce52c7437f7acde61b9c3a2e84e9d49fd2dc33c7e9243053ceed5b247be03
 WHIRLPOOL 
1617687cd2144a09e2fe32b6e9bf49fcdb32f96c2979051f4c0826860eb59572c64c821d8de119f40e5546bc6132773a01702ba76c11be28a28c2926d9ed5c98

diff --git a/net-misc/dhcp/dhcp-4.3.6.ebuild b/net-misc/dhcp/dhcp-4.3.6.ebuild
new file mode 100644
index 00000000000..2404129b81e
--- /dev/null
+++ b/net-misc/dhcp/dhcp-4.3.6.ebuild
@@ -0,0 +1,262 @@
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+inherit systemd toolchain-funcs user
+
+MY_PV="${PV//_alpha/a}"
+MY_PV="${MY_PV//_beta/b}"
+MY_PV="${MY_PV//_rc/rc}"
+MY_PV="${MY_PV//_p/-P}"
+MY_P="${PN}-${MY_PV}"
+DESCRIPTION="ISC Dynamic Host Configuration Protocol (DHCP) client/server"
+HOMEPAGE="http://www.isc.org/products/DHCP";
+SRC_URI="ftp://ftp.isc.org/isc/dhcp/${MY_P}.tar.gz
+       ftp://ftp.isc.org/isc/dhcp/${MY_PV}/${MY_P}.tar.gz";
+
+LICENSE="ISC BSD SSLeay GPL-2" # GPL-2 only for init script
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 
~sh ~sparc ~x86 ~amd64-fbsd ~sparc-fbsd ~x86-fbsd"
+IUSE="+client ipv6 kernel_linux ldap libressl selinux +server ssl vim-syntax"
+
+DEPEND="
+       client? (
+               kernel_linux? (
+                       ipv6? ( sys-apps/iproute2 )
+                       sys-apps/net-tools
+               )
+       )
+       ldap? (
+               net-nds/openldap
+               ssl? (
+                       !libressl? ( dev-libs/openssl:0 )
+                       libressl? ( dev-libs/libressl )
+               )
+       )"
+RDEPEND="${DEPEND}
+       selinux? ( sec-policy/selinux-dhcp )
+       vim-syntax? ( app-vim/dhcpd-syntax )"
+
+S="${WORKDIR}/${MY_P}"
+
+src_unpack() {
+       unpack ${A}
+       # handle local bind hell
+       cd "${S}"/bind
+       unpack ./bind.tar.gz
+}
+
+PATCHES=(
+       # Gentoo patches - these will probably never be accepted upstream
+       # Fix some permission issues
+       "${FILESDIR}/${PN}-3.0-fix-perms.patch"
+
+       # Enable dhclient to equery NTP servers
+       "${FILESDIR}/${PN}-4.3.6-dhclient-ntp.patch"
+       "${FILESDIR}/${PN}-4.3.6-dhclient-resolvconf.patch"
+
+       # Enable dhclient to get extra configuration from stdin
+       "${FILESDIR}/${PN}-4.2.2-dhclient-stdin-conf.patch"
+       "${FILESDIR}/${PN}-4.3.6-nogateway.patch" #265531
+       "${FILESDIR}/${PN}-4.3.6-quieter-ping.patch" #296921
+       "${FILESDIR}/${PN}-4.2.4-always-accept-4.patch" #437108
+       "${FILESDIR}/${PN}-4.3.6-iproute2-path.patch" #480636
+       "${FILESDIR}/${PN}-4.2.5-bindtodevice-inet6.patch" #471142
+       "${FILESDIR}/${PN}-4.3.3-ldap-ipv6-client-id.patch" #559832
+)
+
+src_prepare() {
+       default
+
+       # Brand the version with Gentoo
+       sed -i \
+               -e "/VERSION=/s:'$: Gentoo-${PR}':" \
+               configure || die
+
+       # Change the hook script locations of the scripts
+       sed -i \
+               -e 's,/etc/dhclient-exit-hooks,/etc/dhcp/dhclient-exit-hooks,g' 
\
+               -e 
's,/etc/dhclient-enter-hooks,/etc/dhcp/dhclient-enter-hooks,g' \
+               client/scripts/* || die
+
+       # No need for the linux script to force bash #158540
+       sed -i -e 's,#!/bin/bash,#!/bin/sh,' client/scripts/linux || die
+
+       # Quiet the freebsd logger a little
+       sed -i -e '/LOGGER=/ s/-s -p user.notice //g' client/scripts/freebsd || 
die
+
+       # Remove these options from the sample config
+       sed -i -r \
+               -e "/(script|host-name|domain-name) /d" \
+               client/dhclient.conf.example || die
+
+       if use client && ! use server ; then
+               sed -i -r \
+                       -e '/^SUBDIRS/s:\<(dhcpctl|relay|server)\>::g' \
+                       Makefile.in || die
+       elif ! use client && use server ; then
+               sed -i -r \
+                       -e '/^SUBDIRS/s:\<client\>::' \
+                       Makefile.in || die
+       fi
+
+       # Only install different man pages if we don't have en
+       if [[ " ${LINGUAS} " != *" en "* ]]; then
+               # Install Japanese man pages
+               if [[ " ${LINGUAS} " == *" ja "* && -d doc/ja_JP.eucJP ]]; then
+                       einfo "Installing Japanese documention"
+                       cp doc/ja_JP.eucJP/dhclient* client || die
+                       cp doc/ja_JP.eucJP/dhcp* common || die
+               fi
+       fi
+       # Now remove the non-english docs so there are no errors later
+       rm -r doc/ja_JP.eucJP || die
+
+       # make the bind build work
+       binddir="${S}/bind"
+       cd "${binddir}" || die
+       cat <<-EOF > bindvar.tmp
+       binddir=${binddir}
+       GMAKE=${MAKE:-gmake}
+       EOF
+       eapply -p2 "${FILESDIR}"/${PN}-4.3.4-bind-disable.patch
+       cd bind-*/ || die
+       eapply -p2 "${FILESDIR}"/${PN}-4.2.2-bind-parallel-build.patch #380717
+}
+
+src_configure() {
+       # bind defaults to stupid `/usr/bin/ar`
+       tc-export AR BUILD_CC
+       export ac_cv_path_AR=${AR}
+
+       # this is tested for by the bind build system, and can cause trouble
+       # when cross-building; since dhcp itself doesn't make use of libcap,
+       # simply disable it.
+       export ac_cv_lib_cap_cap_set_proc=no
+
+       # Use FHS sane paths ... some of these have configure options,
+       # but not all, so just do it all here.
+       local e="/etc/dhcp" r="/var/run/dhcp" l="/var/lib/dhcp"
+       cat <<-EOF >> includes/site.h
+       #define _PATH_DHCPD_CONF     "${e}/dhcpd.conf"
+       #define _PATH_DHCLIENT_CONF  "${e}/dhclient.conf"
+       #define _PATH_DHCPD_DB       "${l}/dhcpd.leases"
+       #define _PATH_DHCPD6_DB      "${l}/dhcpd6.leases"
+       #define _PATH_DHCLIENT_DB    "${l}/dhclient.leases"
+       #define _PATH_DHCLIENT6_DB   "${l}/dhclient6.leases"
+       #define _PATH_DHCPD_PID      "${r}/dhcpd.pid"
+       #define _PATH_DHCPD6_PID     "${r}/dhcpd6.pid"
+       #define _PATH_DHCLIENT_PID   "${r}/dhcpclient.pid"
+       #define _PATH_DHCLIENT6_PID  "${r}/dhcpclient6.pid"
+       #define _PATH_DHCRELAY_PID   "${r}/dhcrelay.pid"
+       #define _PATH_DHCRELAY6_PID  "${r}/dhcrelay6.pid"
+       EOF
+
+       local myeconfargs=(
+               --enable-paranoia
+               --enable-early-chroot
+               --sysconfdir=${e}
+               $(use_enable ipv6 dhcpv6)
+               $(use_with ldap)
+               $(use ldap && use_with ssl ldapcrypto || echo 
--without-ldapcrypto)
+       )
+       econf "${myeconfargs[@]}"
+
+       # configure local bind cruft.  symtable option requires
+       # perl and we don't want to require that #383837.
+       cd bind/bind-*/ || die
+       eval econf \
+               $(sed -n '/^bindconfig 
=/,/^$/{:a;N;$!ba;s,^[^-]*,,;s,\\\s*\n\s*--,--,g;s, @[[:upper:]]\+@,,g;P;D}' 
../Makefile.in) \
+               --disable-symtable \
+               --without-make-clean
+}
+
+src_compile() {
+       # build local bind cruft first
+       emake -C bind/bind-*/lib/export install
+       # then build standard dhcp code
+       emake AR="$(tc-getAR)"
+}
+
+src_install() {
+       default
+
+       dodoc README RELNOTES doc/{api+protocol,IANA-arp-parameters}
+       docinto html
+       dodoc doc/References.html
+
+       if [[ -e client/dhclient ]] ; then
+               # move the client to /
+               dodir /sbin
+               mv "${D}"/usr/sbin/dhclient "${D}"/sbin/ || die
+
+               exeinto /sbin
+               if use kernel_linux ; then
+                       newexe "${S}"/client/scripts/linux dhclient-script
+               else
+                       newexe "${S}"/client/scripts/freebsd dhclient-script
+               fi
+       fi
+
+       if [[ -e server/dhcpd ]] ; then
+               if use ldap ; then
+                       insinto /etc/openldap/schema
+                       doins contrib/ldap/dhcp.*
+                       dosbin contrib/ldap/dhcpd-conf-to-ldap
+               fi
+
+               newinitd "${FILESDIR}"/dhcpd.init5 dhcpd
+               newconfd "${FILESDIR}"/dhcpd.conf2 dhcpd
+               newinitd "${FILESDIR}"/dhcrelay.init3 dhcrelay
+               newconfd "${FILESDIR}"/dhcrelay.conf dhcrelay
+               newinitd "${FILESDIR}"/dhcrelay.init3 dhcrelay6
+               newconfd "${FILESDIR}"/dhcrelay6.conf dhcrelay6
+
+               systemd_newtmpfilesd "${FILESDIR}"/dhcpd.tmpfiles dhcpd.conf
+               systemd_dounit "${FILESDIR}"/dhcpd4.service
+               systemd_dounit "${FILESDIR}"/dhcpd6.service
+               systemd_dounit "${FILESDIR}"/dhcrelay4.service
+               systemd_dounit "${FILESDIR}"/dhcrelay6.service
+               systemd_install_serviced "${FILESDIR}"/dhcrelay4.service.conf
+               systemd_install_serviced "${FILESDIR}"/dhcrelay6.service.conf
+
+               sed -i "s:#@slapd@:$(usex ldap slapd ''):" "${ED}"/etc/init.d/* 
|| die #442560
+       fi
+
+       # the default config files aren't terribly useful #384087
+       local f
+       for f in "${ED}"/etc/dhcp/*.conf.example ; do
+               mv "${f}" "${f%.example}" || die
+       done
+       sed -i '/^[^#]/s:^:#:' "${ED}"/etc/dhcp/*.conf || die
+}
+
+pkg_preinst() {
+       enewgroup dhcp
+       enewuser dhcp -1 -1 /var/lib/dhcp dhcp
+
+       # Keep the user files over the sample ones.  The
+       # hashing is to ignore the crappy defaults #384087.
+       local f h
+       for f in dhclient:da7c8496a96452190aecf9afceef4510 
dhcpd:10979e7b71134bd7f04d2a60bd58f070 ; do
+               h=${f#*:}
+               f="/etc/dhcp/${f%:*}.conf"
+               if [ -e "${EROOT}"${f} ] ; then
+                       case $(md5sum "${EROOT}"${f}) in
+                               ${h}*) ;;
+                               *) cp -p "${EROOT}"${f} "${ED}"${f};;
+                       esac
+               fi
+       done
+}
+
+pkg_postinst() {
+       if [[ -e "${ROOT}"/etc/init.d/dhcp ]] ; then
+               ewarn
+               ewarn "WARNING: The dhcp init script has been renamed to dhcpd"
+               ewarn "/etc/init.d/dhcp and /etc/conf.d/dhcp need to be removed 
and"
+               ewarn "and dhcp should be removed from the default runlevel"
+               ewarn
+       fi
+}

diff --git a/net-misc/dhcp/files/dhcp-3.0-fix-perms.patch 
b/net-misc/dhcp/files/dhcp-3.0-fix-perms.patch
index 13debb20ed0..f4b3fd18e16 100644
--- a/net-misc/dhcp/files/dhcp-3.0-fix-perms.patch
+++ b/net-misc/dhcp/files/dhcp-3.0-fix-perms.patch
@@ -1,5 +1,5 @@
---- server/dhcpd.c     2003-11-05 14:08:09.000000000 -0800
-+++ server/dhcpd.c     2003-11-05 14:15:32.000000000 -0800
+--- a/server/dhcpd.c
++++ b/server/dhcpd.c
 @@ -602,6 +602,12 @@
        if (lftest)
                exit (0);

diff --git a/net-misc/dhcp/files/dhcp-3.0.3-dhclient-no-down.patch 
b/net-misc/dhcp/files/dhcp-3.0.3-dhclient-no-down.patch
index 518efec11c5..3a3b956e361 100644
--- a/net-misc/dhcp/files/dhcp-3.0.3-dhclient-no-down.patch
+++ b/net-misc/dhcp/files/dhcp-3.0.3-dhclient-no-down.patch
@@ -1,5 +1,5 @@
---- client/scripts/linux
-+++ client/scripts/linux
+--- a/client/scripts/linux
++++ b/client/scripts/linux
 @@ -118,9 +118,9 @@
  if [ x$reason = xPREINIT ]; then
    if [ x$alias_ip_address != x ]; then

diff --git a/net-misc/dhcp/files/dhcp-4.3.6-dhclient-ntp.patch 
b/net-misc/dhcp/files/dhcp-4.3.6-dhclient-ntp.patch
new file mode 100644
index 00000000000..a504840dd5a
--- /dev/null
+++ b/net-misc/dhcp/files/dhcp-4.3.6-dhclient-ntp.patch
@@ -0,0 +1,210 @@
+--- dhcp-4.3.6/client/clparse.c
++++ dhcp-4.3.6/client/clparse.c
+@@ -31,7 +31,7 @@
+ 
+ struct client_config top_level_config;
+ 
+-#define NUM_DEFAULT_REQUESTED_OPTS    9
++#define NUM_DEFAULT_REQUESTED_OPTS    10
+ /* There can be 2 extra requested options for DHCPv4-over-DHCPv6. */
+ struct option *default_requested_options[NUM_DEFAULT_REQUESTED_OPTS + 2 + 1];
+ 
+@@ -107,15 +107,20 @@
+                               dhcp_universe.code_hash, &code, 0, MDL);
+ 
+       /* 8 */
+-      code = D6O_NAME_SERVERS;
++      code = DHO_NTP_SERVERS;
+       option_code_hash_lookup(&default_requested_options[7],
+-                              dhcpv6_universe.code_hash, &code, 0, MDL);
++                              dhcp_universe.code_hash, &code, 0, MDL);
+ 
+       /* 9 */
+-      code = D6O_DOMAIN_SEARCH;
++      code = D6O_NAME_SERVERS;
+       option_code_hash_lookup(&default_requested_options[8],
+                               dhcpv6_universe.code_hash, &code, 0, MDL);
+ 
++      /* 10 */
++      code = D6O_DOMAIN_SEARCH;
++      option_code_hash_lookup(&default_requested_options[9],
++                              dhcpv6_universe.code_hash, &code, 0, MDL);
++
+       for (code = 0 ; code < NUM_DEFAULT_REQUESTED_OPTS ; code++) {
+               if (default_requested_options[code] == NULL)
+                       log_fatal("Unable to find option definition for "
+--- dhcp-4.3.6/client/scripts/bsdos
++++ dhcp-4.3.6/client/scripts/bsdos
+@@ -36,6 +36,26 @@
+ 
+     mv /etc/resolv.conf.dhclient6 /etc/resolv.conf
+   fi
++  # If we're making confs, may as well make an ntp.conf too
++  make_ntp_conf
++}
++
++make_ntp_conf() {
++  if [ x$PEER_NTP = x ] || [ x$PEER_NTP = xyes ]; then
++    if [ x$new_ntp_servers != x ]; then
++      conf="# Generated by dhclient for interface $interface\n"
++      conf="${conf}restrict default noquery notrust nomodify\n"
++      conf="${conf}restrict 127.0.0.1\n"
++      for ntpserver in $new_ntp_servers; do
++        conf="${conf}restrict $ntpserver nomodify notrap noquery\n"
++        conf="${conf}server $ntpserver\n"
++      done
++      conf="${conf}driftfile /var/lib/ntp/ntp.drift\n"
++      conf="${conf}logfile /var/log/ntp.log\n"
++      printf "${conf}" > /etc/ntp.conf
++      chmod 644 /etc/ntp.conf
++    fi
++  fi
+ }
+ 
+ # Must be used on exit.   Invokes the local dhcp client exit hooks, if any.
+--- dhcp-4.3.6/client/scripts/freebsd
++++ dhcp-4.3.6/client/scripts/freebsd
+@@ -80,6 +80,26 @@
+       fi
+     fi
+   fi
++  # If we're making confs, may as well make an ntp.conf too
++  make_ntp_conf
++}
++
++make_ntp_conf() {
++  if [ x$PEER_NTP = x ] || [ x$PEER_NTP = xyes ]; then
++    if [ "x$new_ntp_servers" != x ]; then
++      conf="# Generated by dhclient for interface $interface\n"
++      conf="${conf}restrict default noquery notrust nomodify\n"
++      conf="${conf}restrict 127.0.0.1\n"
++      for ntpserver in $new_ntp_servers; do
++        conf="${conf}restrict $ntpserver nomodify notrap noquery\n"
++        conf="${conf}server $ntpserver\n"
++      done
++      conf="${conf}driftfile /var/lib/ntp/ntp.drift\n"
++      conf="${conf}logfile /var/log/ntp.log\n"
++      printf "${conf}" > /etc/ntp.conf
++      chmod 644 /etc/ntp.conf
++    fi
++  fi
+ }
+ 
+ # Must be used on exit.   Invokes the local dhcp client exit hooks, if any.
+--- dhcp-4.3.6/client/scripts/linux
++++ dhcp-4.3.6/client/scripts/linux
+@@ -106,6 +106,27 @@
+       fi
+         mv -f $new_resolv_conf /etc/resolv.conf
+     fi
++
++    # If we're making confs, may as well make an ntp.conf too
++    make_ntp_conf
++}
++
++make_ntp_conf() {
++    if [ x$PEER_NTP = x ] || [ x$PEER_NTP = xyes ]; then
++      if [ "x$new_ntp_servers" != x ]; then
++          conf="# Generated by dhclient for interface $interface\n"
++          conf="${conf}restrict default noquery notrust nomodify\n"
++          conf="${conf}restrict 127.0.0.1\n"
++          for ntpserver in $new_ntp_servers; do
++              conf="${conf}restrict $ntpserver nomodify notrap noquery\n"
++              conf="${conf}server $ntpserver\n"
++          done
++          conf="${conf}driftfile /var/lib/ntp/ntp.drift\n"
++          conf="${conf}logfile /var/log/ntp.log\n"
++          printf "${conf}" > /etc/ntp.conf
++          chmod 644 /etc/ntp.conf
++      fi
++    fi
+ }
+ 
+ # set host name
+--- dhcp-4.3.6/client/scripts/netbsd
++++ dhcp-4.3.6/client/scripts/netbsd
+@@ -36,6 +36,26 @@
+ 
+     mv /etc/resolv.conf.dhclient6 /etc/resolv.conf
+   fi
++  # If we're making confs, may as well make an ntp.conf too
++  make_ntp_conf
++}
++
++make_ntp_conf() {
++  if [ x$PEER_NTP = x ] || [ x$PEER_NTP = xyes ]; then
++    if [ "x$new_ntp_servers" != x ]; then
++      conf="# Generated by dhclient for interface $interface\n"
++      conf="${conf}restrict default noquery notrust nomodify\n"
++      conf="${conf}restrict 127.0.0.1\n"
++      for ntpserver in $new_ntp_servers; do
++        conf="${conf}restrict $ntpserver nomodify notrap noquery\n"
++        conf="${conf}server $ntpserver\n"
++      done
++      conf="${conf}driftfile /var/lib/ntp/ntp.drift\n"
++      conf="${conf}logfile /var/log/ntp.log\n"
++      printf "${conf}" > /etc/ntp.conf
++      chmod 644 /etc/ntp.conf
++    fi
++  fi
+ }
+ 
+ # Must be used on exit.   Invokes the local dhcp client exit hooks, if any.
+--- dhcp-4.3.6/client/scripts/openbsd
++++ dhcp-4.3.6/client/scripts/openbsd
+@@ -36,6 +36,26 @@
+ 
+     mv /etc/resolv.conf.dhclient6 /etc/resolv.conf
+   fi
++  # If we're making confs, may as well make an ntp.conf too
++  make_ntp_conf
++}
++
++make_ntp_conf() {
++  if [ x$PEER_NTP = x ] || [ x$PEER_NTP = xyes ]; then
++    if [ "x$new_ntp_servers" != x ]; then
++      conf="# Generated by dhclient for interface $interface\n"
++      conf="${conf}restrict default noquery notrust nomodify\n"
++      conf="${conf}restrict 127.0.0.1\n"
++      for ntpserver in $new_ntp_servers; do
++        conf="${conf}restrict $ntpserver nomodify notrap noquery\n"
++        conf="${conf}server $ntpserver\n"
++      done
++      conf="${conf}driftfile /var/lib/ntp/ntp.drift\n"
++      conf="${conf}logfile /var/log/ntp.log\n"
++      printf "${conf}" > /etc/ntp.conf
++      chmod 644 /etc/ntp.conf
++    fi
++  fi
+ }
+ 
+ # Must be used on exit.   Invokes the local dhcp client exit hooks, if any.
+--- dhcp-4.3.6/client/scripts/solaris
++++ dhcp-4.3.6/client/scripts/solaris
+@@ -17,6 +17,26 @@
+ 
+     mv /etc/resolv.conf.dhclient /etc/resolv.conf
+   fi
++  # If we're making confs, may as well make an ntp.conf too
++  make_ntp_conf
++}
++
++make_ntp_conf() {
++  if [ x$PEER_NTP = x ] || [ x$PEER_NTP = xyes ]; then
++    if [ "x$new_ntp_servers" != x ]; then
++      conf="# Generated by dhclient for interface $interface\n"
++      conf="${conf}restrict default noquery notrust nomodify\n"
++      conf="${conf}restrict 127.0.0.1\n"
++      for ntpserver in $new_ntp_servers; do
++        conf="${conf}restrict $ntpserver nomodify notrap noquery\n"
++        conf="${conf}server $ntpserver\n"
++      done
++      conf="${conf}driftfile /var/lib/ntp/ntp.drift\n"
++      conf="${conf}logfile /var/log/ntp.log\n"
++      printf "${conf}" > /etc/ntp.conf
++      chmod 644 /etc/ntp.conf
++    fi
++  fi
+ }
+ 
+ # Must be used on exit.   Invokes the local dhcp client exit hooks, if any.

diff --git a/net-misc/dhcp/files/dhcp-4.3.6-dhclient-resolvconf.patch 
b/net-misc/dhcp/files/dhcp-4.3.6-dhclient-resolvconf.patch
new file mode 100644
index 00000000000..ccfdbcf4a20
--- /dev/null
+++ b/net-misc/dhcp/files/dhcp-4.3.6-dhclient-resolvconf.patch
@@ -0,0 +1,422 @@
+--- dhcp-4.3.6/client/scripts/bsdos
++++ dhcp-4.3.6/client/scripts/bsdos
+@@ -1,27 +1,25 @@
+ #!/bin/sh
+ 
+ make_resolv_conf() {
++  if [ x"$PEER_DNS" != x ] && [ x"$PEER_DNS" != xyes ]; then
++    return 0
++  fi
++  local conf=
+   if [ x"$new_domain_name_servers" != x ]; then
+-    cat /dev/null > /etc/resolv.conf.dhclient
+     if [ "x$new_domain_search" != x ]; then
+-      echo search $new_domain_search >> /etc/resolv.conf.dhclient
++      conf="${conf}search ${new_domain_search}\n"
+     elif [ "x$new_domain_name" != x ]; then
+       # Note that the DHCP 'Domain Name Option' is really just a domain
+       # name, and that this practice of using the domain name option as
+       # a search path is both nonstandard and deprecated.
+-      echo search $new_domain_name >> /etc/resolv.conf.dhclient
++      conf="${conf}search ${new_domain_name}\n"
+     fi
+     for nameserver in $new_domain_name_servers; do
+-      echo nameserver $nameserver >> /etc/resolv.conf.dhclient
++      conf="${conf}nameserver ${nameserver}\n"
+     done
+-
+-    mv /etc/resolv.conf.dhclient /etc/resolv.conf
+   elif [ "x${new_dhcp6_name_servers}" != x ] ; then
+-    cat /dev/null > /etc/resolv.conf.dhclient6
+-    chmod 644 /etc/resolv.conf.dhclient6
+-
+     if [ "x${new_dhcp6_domain_search}" != x ] ; then
+-      echo search ${new_dhcp6_domain_search} >> /etc/resolv.conf.dhclient6
++      conf="${conf}search ${new_dhcp6_domain_search}\n"
+     fi
+     for nameserver in ${new_dhcp6_name_servers} ; do
+       # If the nameserver has a link-local address
+@@ -31,10 +29,18 @@
+         FE80:*) zone_id="%$interface";;
+         *)      zone_id="";;
+       esac
+-      echo nameserver ${nameserver}$zone_id >> /etc/resolv.conf.dhclient6
++      conf="${conf}nameserver ${nameserver}$zone_id\n"
+     done
++  fi
+ 
+-    mv /etc/resolv.conf.dhclient6 /etc/resolv.conf
++  if [ x"$conf" != x ]; then
++    conf="# Generated by dhclient or interface $interface\n${conf}"
++    if type resolvconf >/dev/null 2>&1; then
++      printf "${conf}" | resolvconf -a $interface
++    else
++      printf "${conf}" > /etc/resolv.conf
++      chmod 644 /etc/resolv.conf
++    fi
+   fi
+ }
+ 
+--- dhcp-4.3.6/client/scripts/freebsd
++++ dhcp-4.3.6/client/scripts/freebsd
+@@ -11,54 +11,23 @@
+ fi
+ 
+ make_resolv_conf() {
++  if [ x"$PEER_DNS" != x ] && [ x"$PEER_DNS" != xyes ]; then
++    return 0
++  fi
++  local conf=
+   if [ x"$new_domain_name_servers" != x ]; then
+-    ( cat /dev/null > /etc/resolv.conf.dhclient )
+-    exit_status=$?
+-    if [ $exit_status -ne 0 ]; then
+-      $LOGGER "Unable to create /etc/resolv.conf.dhclient: Error $exit_status"
+-    else
+-      if [ "x$new_domain_search" != x ]; then
+-      ( echo search $new_domain_search >> /etc/resolv.conf.dhclient )
+-      exit_status=$?
+-      elif [ "x$new_domain_name" != x ]; then
+-      # Note that the DHCP 'Domain Name Option' is really just a domain
+-      # name, and that this practice of using the domain name option as
+-      # a search path is both nonstandard and deprecated.
+-      ( echo search $new_domain_name >> /etc/resolv.conf.dhclient )
+-      exit_status=$?
+-      fi
+-      for nameserver in $new_domain_name_servers; do
+-      if [ $exit_status -ne 0 ]; then
+-        break
+-      fi
+-      ( echo nameserver $nameserver >>/etc/resolv.conf.dhclient )
+-      exit_status=$?
+-      done
+-
+-      # If there were no errors, attempt to mv the new file into place.
+-      if [ $exit_status -eq 0 ]; then
+-      ( mv /etc/resolv.conf.dhclient /etc/resolv.conf )
+-      exit_status=$?
+-      fi
+-
+-      if [ $exit_status -ne 0 ]; then
+-      $LOGGER "Error while writing new /etc/resolv.conf."
+-      fi
++    if [ "x$new_domain_search" != x ]; then
++      conf="${conf}search ${new_domain_search}\n"
++    elif [ "x$new_domain_name" != x ]; then
++      # Note that the DHCP 'Domain Name Option' is really just a domain
++      # name, and that this practice of using the domain name option as
++      # a search path is both nonstandard and deprecated.
++      conf="${conf}search ${new_domain_name}\n"
+     fi
++    for nameserver in $new_domain_name_servers; do
++      conf="${conf}nameserver ${nameserver}\n"
++    done
+   elif [ "x${new_dhcp6_name_servers}" != x ] ; then
+-    ( cat /dev/null > /etc/resolv.conf.dhclient6 )
+-    exit_status=$?
+-    if [ $exit_status -ne 0 ] ; then
+-      $LOGGER "Unable to create /etc/resolv.conf.dhclient6: Error 
$exit_status"
+-    else
+-      if [ "x${new_dhcp6_domain_search}" != x ] ; then
+-      ( echo search ${new_dhcp6_domain_search} >> /etc/resolv.conf.dhclient6 )
+-      exit_status=$?
+-      fi
+-      for nameserver in ${new_dhcp6_name_servers} ; do
+-      if [ $exit_status -ne 0 ] ; then
+-        break
+-      fi
+       # If the nameserver has a link-local address
+       # add a <zone_id> (interface name) to it.
+       case $nameserver in
+@@ -66,18 +35,21 @@
+           FE80:*) zone_id="%$interface";;
+           *)      zone_id="";;
+       esac
+-      ( echo nameserver ${nameserver}$zone_id >> /etc/resolv.conf.dhclient6 )
+-      exit_status=$?
+-      done
+-
+-      if [ $exit_status -eq 0 ] ; then
+-        ( mv /etc/resolv.conf.dhclient6 /etc/resolv.conf )
+-      exit_status=$?
+-      fi
++    if [ "x${new_dhcp6_domain_search}" != x ] ; then
++      conf="${conf}search ${new_dhcp6_domain_search}\n"
++    fi
++    for nameserver in ${new_dhcp6_name_servers} ; do
++      conf="${conf}nameserver ${nameserver}$zone_id\n"
++    done
++  fi
+ 
+-      if [ $exit_status -ne 0 ] ; then
+-      $LOGGER "Error while writing new /etc/resolv.conf."
+-      fi
++  if [ x"$conf" != x ]; then
++    conf="# Generated by dhclient or interface $interface\n${conf}"
++    if type resolvconf >/dev/null 2>&1; then
++      printf "${conf}" | resolvconf -a $interface
++    else
++      printf "${conf}" > /etc/resolv.conf
++      chmod 644 /etc/resolv.conf
+     fi
+   fi
+ }
+--- dhcp-4.3.6/client/scripts/linux
++++ dhcp-4.3.6/client/scripts/linux
+@@ -35,16 +35,16 @@
+ # update /etc/resolv.conf based on received values
+ # This updated version mostly follows Debian script by Andrew Pollock et al.
+ make_resolv_conf() {
+-    local new_resolv_conf
++    if [ x"$PEER_DNS" != x ] && [ x"$PEER_DNS" != xyes ]; then
++      return 0
++    fi
++    local conf
+ 
+     # DHCPv4
+     if [ -n "$new_domain_search" ] || [ -n "$new_domain_name" ] ||
+        [ -n "$new_domain_name_servers" ]; then
+-        new_resolv_conf=/etc/resolv.conf.dhclient-new
+-        rm -f $new_resolv_conf
+-
+         if [ -n "$new_domain_name" ]; then
+-            echo domain ${new_domain_name%% *} >>$new_resolv_conf
++            conf="${conf}domain ${new_domain_name%% *}\n"
+         fi
+ 
+         if [ -n "$new_domain_search" ]; then
+@@ -60,31 +60,23 @@
+                     new_domain_search="$new_domain_name $new_domain_search"
+                 fi
+             fi
+-            echo "search ${new_domain_search}" >> $new_resolv_conf
++            conf="${conf}search ${new_domain_search}\n"
+         elif [ -n "$new_domain_name" ]; then
+-            echo "search ${new_domain_name}" >> $new_resolv_conf
++            conf="${conf}search ${new_domain_name}\n"
+         fi
+ 
+         if [ -n "$new_domain_name_servers" ]; then
+             for nameserver in $new_domain_name_servers; do
+-                echo nameserver $nameserver >>$new_resolv_conf
++                conf="${conf}nameserver $nameserver\n"
+             done
+         else # keep 'old' nameservers
+-            sed -n /^\w*[Nn][Aa][Mm][Ee][Ss][Ee][Rr][Vv][Ee][Rr]/p 
/etc/resolv.conf >>$new_resolv_conf
++            conf="${conf}$(sed -n 
/^\w*[Nn][Aa][Mm][Ee][Ss][Ee][Rr][Vv][Ee][Rr]/p /etc/resolv.conf)\n"
+         fi
+ 
+-      if [ -f /etc/resolv.conf ]; then
+-          chown --reference=/etc/resolv.conf $new_resolv_conf
+-          chmod --reference=/etc/resolv.conf $new_resolv_conf
+-      fi
+-        mv -f $new_resolv_conf /etc/resolv.conf
+     # DHCPv6
+     elif [ -n "$new_dhcp6_domain_search" ] || [ -n "$new_dhcp6_name_servers" 
]; then
+-        new_resolv_conf=/etc/resolv.conf.dhclient-new
+-        rm -f $new_resolv_conf
+-
+         if [ -n "$new_dhcp6_domain_search" ]; then
+-            echo "search ${new_dhcp6_domain_search}" >> $new_resolv_conf
++            conf="${conf}search ${new_dhcp6_domain_search}\n"
+         fi
+ 
+         if [ -n "$new_dhcp6_name_servers" ]; then
+@@ -94,17 +86,21 @@
+                    [ "${nameserver##FE80::}" != "$nameserver" ]; then
+                     nameserver="${nameserver}%${interface}"
+                 fi
+-                echo nameserver $nameserver >>$new_resolv_conf
++                conf="${conf}nameserver $nameserver\n"
+             done
+         else # keep 'old' nameservers
+-            sed -n /^\w*[Nn][Aa][Mm][Ee][Ss][Ee][Rr][Vv][Ee][Rr]/p 
/etc/resolv.conf >>$new_resolv_conf
++            conf="${conf}$(sed -n 
/^\w*[Nn][Aa][Mm][Ee][Ss][Ee][Rr][Vv][Ee][Rr]/p /etc/resolv.conf)\n"
+         fi
++    fi
+ 
+-      if [ -f /etc/resolv.conf ]; then
+-            chown --reference=/etc/resolv.conf $new_resolv_conf
+-            chmod --reference=/etc/resolv.conf $new_resolv_conf
++    if [ x"$conf" != x ]; then
++      conf="# Generated by dhclient or interface $interface\n${conf}"
++      if type resolvconf >/dev/null 2>&1; then
++          printf "${conf}" | resolvconf -a $interface
++      else
++          printf "${conf}" > /etc/resolv.conf
++          chmod 644 /etc/resolv.conf
+       fi
+-        mv -f $new_resolv_conf /etc/resolv.conf
+     fi
+ }
+ 
+--- dhcp-4.3.6/client/scripts/netbsd
++++ dhcp-4.3.6/client/scripts/netbsd
+@@ -1,27 +1,25 @@
+ #!/bin/sh
+ 
+ make_resolv_conf() {
+-  if [ "x$new_domain_name" != x ] && [ x"$new_domain_name_servers" != x ]; 
then
+-    cat /dev/null > /etc/resolv.conf.dhclient
++  if [ x"$PEER_DNS" != x ] && [ x"$PEER_DNS" != xyes ]; then
++    return 0
++  fi
++  local conf=
++  if [ x"$new_domain_name_servers" != x ]; then
+     if [ "x$new_domain_search" != x ]; then
+-      echo search $new_domain_search >> /etc/resolv.conf.dhclient
++      conf="${conf}search ${new_domain_search}\n"
+     elif [ "x$new_domain_name" != x ]; then
+       # Note that the DHCP 'Domain Name Option' is really just a domain
+       # name, and that this practice of using the domain name option as
+       # a search path is both nonstandard and deprecated.
+-      echo search $new_domain_name >> /etc/resolv.conf.dhclient
++      conf="${conf}search ${new_domain_name}\n"
+     fi
+     for nameserver in $new_domain_name_servers; do
+-      echo nameserver $nameserver >>/etc/resolv.conf.dhclient
++      conf="${conf}nameserver ${nameserver}\n"
+     done
+-
+-    mv /etc/resolv.conf.dhclient /etc/resolv.conf
+   elif [ "x${new_dhcp6_name_servers}" != x ] ; then
+-    cat /dev/null > /etc/resolv.conf.dhclient6
+-    chmod 644 /etc/resolv.conf.dhclient6
+-
+     if [ "x${new_dhcp6_domain_search}" != x ] ; then
+-      echo search ${new_dhcp6_domain_search} >> /etc/resolv.conf.dhclient6
++      conf="${conf}search ${new_dhcp6_domain_search}\n"
+     fi
+     for nameserver in ${new_dhcp6_name_servers} ; do
+       # If the nameserver has a link-local address
+@@ -31,10 +29,18 @@
+       FE80:*) zone_id="%$interface";;
+       *)      zone_id="";;
+       esac
+-      echo nameserver ${nameserver}$zone_id >> /etc/resolv.conf.dhclient6
++      conf="${conf}nameserver ${nameserver}$zone_id\n"
+     done
++  fi
+ 
+-    mv /etc/resolv.conf.dhclient6 /etc/resolv.conf
++  if [ x"$conf" != x ]; then
++    conf="# Generated by dhclient or interface $interface\n${conf}"
++    if type resolvconf >/dev/null 2>&1; then
++      printf "${conf}" | resolvconf -a $interface
++    else
++      printf "${conf}" > /etc/resolv.conf
++      chmod 644 /etc/resolv.conf
++    fi
+   fi
+ }
+ 
+--- dhcp-4.3.6/client/scripts/openbsd
++++ dhcp-4.3.6/client/scripts/openbsd
+@@ -1,27 +1,25 @@
+ #!/bin/sh
+ 
+ make_resolv_conf() {
++  if [ x"$PEER_DNS" != x ] && [ x"$PEER_DNS" != xyes ]; then
++    return 0
++  fi
++  local conf=
+   if [ x"$new_domain_name_servers" != x ]; then
+-    cat /dev/null > /etc/resolv.conf.dhclient
+-    if [ x"$new_domain_search" != x ]; then
+-      echo search $new_domain_search >> /etc/resolv.conf.dhclient
+-    elif [ x"$new_domain_name" != x ]; then
++    if [ "x$new_domain_search" != x ]; then
++      conf="${conf}search ${new_domain_search}\n"
++    elif [ "x$new_domain_name" != x ]; then
+       # Note that the DHCP 'Domain Name Option' is really just a domain
+       # name, and that this practice of using the domain name option as
+       # a search path is both nonstandard and deprecated.
+-      echo search $new_domain_name >> /etc/resolv.conf.dhclient
++      conf="${conf}search ${new_domain_name}\n"
+     fi
+     for nameserver in $new_domain_name_servers; do
+-      echo nameserver $nameserver >>/etc/resolv.conf.dhclient
++      conf="${conf}nameserver ${nameserver}\n"
+     done
+-
+-    mv /etc/resolv.conf.dhclient /etc/resolv.conf
+   elif [ "x${new_dhcp6_name_servers}" != x ] ; then
+-    cat /dev/null > /etc/resolv.conf.dhclient6
+-    chmod 644 /etc/resolv.conf.dhclient6
+-
+     if [ "x${new_dhcp6_domain_search}" != x ] ; then
+-      echo search ${new_dhcp6_domain_search} >> /etc/resolv.conf.dhclient6
++      conf="${conf}search ${new_dhcp6_domain_search}\n"
+     fi
+     for nameserver in ${new_dhcp6_name_servers} ; do
+       # If the nameserver has a link-local address
+@@ -31,10 +29,18 @@
+       FE80:*) zone_id="%$interface";;
+       *)      zone_id="";;
+       esac
+-      echo nameserver ${nameserver}$zone_id >> /etc/resolv.conf.dhclient6
++      conf="${conf}nameserver ${nameserver}$zone_id\n"
+     done
++  fi
+ 
+-    mv /etc/resolv.conf.dhclient6 /etc/resolv.conf
++  if [ x"$conf" != x ]; then
++    conf="# Generated by dhclient or interface $interface\n${conf}"
++    if type resolvconf >/dev/null 2>&1; then
++      printf "${conf}" | resolvconf -a $interface
++    else
++      printf "${conf}" > /etc/resolv.conf
++      chmod 644 /etc/resolv.conf
++    fi
+   fi
+ }
+ 
+--- dhcp-4.3.6/client/scripts/solaris
++++ dhcp-4.3.6/client/scripts/solaris
+@@ -1,21 +1,39 @@
+ #!/bin/sh  
+ 
+ make_resolv_conf() {
++  if [ x"$PEER_DNS" != x ] && [ x"$PEER_DNS" != xyes ]; then
++    return 0
++  fi
++  local conf=
+   if [ x"$new_domain_name_servers" != x ]; then
+-    cat /dev/null > /etc/resolv.conf.dhclient
+-    if [ x"$new_domain_search" != x ]; then
+-      echo search $new_domain_search >> /etc/resolv.conf.dhclient
+-    elif [ x"$new_domain_name" != x ]; then
++    if [ "x$new_domain_search" != x ]; then
++      conf="${conf}search ${new_domain_search}\n"
++    elif [ "x$new_domain_name" != x ]; then
+       # Note that the DHCP 'Domain Name Option' is really just a domain
+       # name, and that this practice of using the domain name option as
+       # a search path is both nonstandard and deprecated.
+-      echo search $new_domain_name >> /etc/resolv.conf.dhclient
++      conf="${conf}search ${new_domain_name}\n"
+     fi
+     for nameserver in $new_domain_name_servers; do
+-      echo nameserver $nameserver >>/etc/resolv.conf.dhclient
++      conf="${conf}nameserver ${nameserver}\n"
++    done
++  elif [ "x${new_dhcp6_name_servers}" != x ] ; then
++    if [ "x${new_dhcp6_domain_search}" != x ] ; then
++      conf="${conf}search ${new_dhcp6_domain_search}\n"
++    fi
++    for nameserver in ${new_dhcp6_name_servers} ; do
++      conf="${conf}nameserver ${nameserver}\n"
+     done
++  fi
+ 
+-    mv /etc/resolv.conf.dhclient /etc/resolv.conf
++  if [ x"$conf" != x ]; then
++    conf="# Generated by dhclient or interface $interface\n${conf}"
++    if type resolvconf >/dev/null 2>&1; then
++      printf "${conf}" | resolvconf -a $interface
++    else
++      printf "${conf}" > /etc/resolv.conf
++      chmod 644 /etc/resolv.conf
++    fi
+   fi
+ }
+ 

diff --git a/net-misc/dhcp/files/dhcp-4.3.6-iproute2-path.patch 
b/net-misc/dhcp/files/dhcp-4.3.6-iproute2-path.patch
new file mode 100644
index 00000000000..18b04e620c1
--- /dev/null
+++ b/net-misc/dhcp/files/dhcp-4.3.6-iproute2-path.patch
@@ -0,0 +1,11 @@
+--- dhcp-4.3.6/client/scripts/linux
++++ dhcp-4.3.6/client/scripts/linux
+@@ -30,7 +30,7 @@
+ # 'ip' just looks too weird. Also, we now have unit-tests! Those unit-tests
+ # overwirte this line to use a fake ip-echo tool. It's also convenient
+ # if your system holds ip tool in a non-standard location.
+-ip=/sbin/ip
++ip=ip
+ 
+ # update /etc/resolv.conf based on received values
+ # This updated version mostly follows Debian script by Andrew Pollock et al.

diff --git a/net-misc/dhcp/files/dhcp-4.3.6-nogateway.patch 
b/net-misc/dhcp/files/dhcp-4.3.6-nogateway.patch
new file mode 100644
index 00000000000..d299cc503f6
--- /dev/null
+++ b/net-misc/dhcp/files/dhcp-4.3.6-nogateway.patch
@@ -0,0 +1,66 @@
+--- dhcp-4.3.6/client/scripts/linux
++++ dhcp-4.3.6/client/scripts/linux
+@@ -242,20 +242,22 @@
+                       if_metric=${if_metric:-1}
+                   fi
+ 
+-                  for router in $new_routers; do
+-                      if [ "$new_subnet_mask" = "255.255.255.255" ]; then
+-                          # point-to-point connection => set explicit route
+-                          ${ip} -4 route add ${router} dev $interface 
>/dev/null 2>&1
+-                      fi
+-
+-                      # set default route
+-                      ${ip} -4 route add default via ${router} dev 
${interface} \
+-                          ${if_metric:+metric $if_metric} >/dev/null 2>&1
+-
+-                      if [ -n "$if_metric" ]; then
+-                          if_metric=$((if_metric+1))
+-                      fi
+-                  done
++                  if [ x$PEER_ROUTERS = x ] || [ x$PEER_ROUTERS = xyes ]; then
++                      for router in $new_routers; do
++                          if [ "$new_subnet_mask" = "255.255.255.255" ]; then
++                              # point-to-point connection => set explicit 
route
++                              ${ip} -4 route add ${router} dev $interface 
>/dev/null 2>&1
++                          fi
++
++                          # set default route
++                          ${ip} -4 route add default via ${router} dev 
${interface} \
++                              ${if_metric:+metric $if_metric} >/dev/null 2>&1
++
++                          if [ -n "$if_metric" ]; then
++                              if_metric=$((if_metric+1))
++                          fi
++                      done
++                  fi
+           fi
+         fi
+ 
+@@ -330,15 +332,17 @@
+                       if_metric=${if_metric:-1}
+                   fi
+ 
+-                  # set default route
+-                  for router in $new_routers; do
+-                      ${ip} -4 route add default via ${router} dev 
${interface} \
+-                          ${if_metric:+metric $if_metric} >/dev/null 2>&1
+-
+-                      if [ -n "$if_metric" ]; then
+-                          if_metric=$((if_metric+1))
+-                      fi
+-                  done
++                  if [ x$PEER_ROUTERS = x ] || [ x$PEER_ROUTERS = xyes ]; then
++                      # set default route
++                      for router in $new_routers; do
++                          ${ip} -4 route add default via ${router} dev 
${interface} \
++                              ${if_metric:+metric $if_metric} >/dev/null 2>&1
++
++                          if [ -n "$if_metric" ]; then
++                              if_metric=$((if_metric+1))
++                          fi
++                      done
++                  fi
+           fi
+ 
+             # update /etc/resolv.conf

diff --git a/net-misc/dhcp/files/dhcp-4.3.6-quieter-ping.patch 
b/net-misc/dhcp/files/dhcp-4.3.6-quieter-ping.patch
new file mode 100644
index 00000000000..3efb6459ebf
--- /dev/null
+++ b/net-misc/dhcp/files/dhcp-4.3.6-quieter-ping.patch
@@ -0,0 +1,66 @@
+--- dhcp-4.3.6/client/scripts/bsdos
++++ dhcp-4.3.6/client/scripts/bsdos
+@@ -220,7 +220,7 @@
+   sleep 1
+   if [ "$new_routers" != "" ]; then
+     set $new_routers
+-    if ping -q -c 1 -w 1 $1; then
++    if ping -q -c 1 -w 1 $1 >/dev/null; then
+       if [ x$new_ip_address != x$alias_ip_address ] && \
+                       [ x$alias_ip_address != x ]; then
+       ifconfig $interface inet alias $alias_ip_address $alias_subnet_arg
+--- dhcp-4.3.6/client/scripts/freebsd
++++ dhcp-4.3.6/client/scripts/freebsd
+@@ -287,7 +287,7 @@
+   if [ -n "$new_routers" ]; then
+     $LOGGER "New Routers: $new_routers"
+     set -- $new_routers
+-    if ping -q -c 1 $1; then
++    if ping -q -c 1 $1 >/dev/null; then
+       if [ x$new_ip_address != x$alias_ip_address ] && \
+                       [ x$alias_ip_address != x ]; then
+       ifconfig $interface inet alias $alias_ip_address $alias_subnet_arg
+--- dhcp-4.3.6/client/scripts/linux
++++ dhcp-4.3.6/client/scripts/linux
+@@ -311,7 +311,7 @@
+         fi
+ 
+         # if there is no router recorded in the lease or the 1st router 
answers pings
+-        if [ -z "$new_routers" ] || ping -q -c 1 "${new_routers%% *}"; then
++        if [ -z "$new_routers" ] || ping -q -c 1 "${new_routers%% *}" 
>/dev/null; then
+           # if we have $new_rfc3442_classless_static_routes then we have to
+           # ignore $new_routers entirely
+           if [ ! "$new_rfc3442_classless_static_routes" ]; then
+--- dhcp-4.3.6/client/scripts/netbsd
++++ dhcp-4.3.6/client/scripts/netbsd
+@@ -220,7 +220,7 @@
+   sleep 1
+   if [ "$new_routers" != "" ]; then
+     set $new_routers
+-    if ping -q -c 1 -w 1 $1; then
++    if ping -q -c 1 -w 1 $1 >/dev/null; then
+       if [ x$new_ip_address != x$alias_ip_address ] && \
+                       [ x$alias_ip_address != x ]; then
+       ifconfig $interface inet alias $alias_ip_address $alias_subnet_arg
+--- dhcp-4.3.6/client/scripts/openbsd
++++ dhcp-4.3.6/client/scripts/openbsd
+@@ -214,7 +214,7 @@
+   sleep 1
+   if [ "$new_routers" != "" ]; then
+     set $new_routers
+-    if ping -q -c 1 -w 1 $1; then
++    if ping -q -c 1 -w 1 $1 >/dev/null; then
+       if [ x$new_ip_address != x$alias_ip_address ] && \
+                       [ x$alias_ip_address != x ]; then
+       ifconfig $interface inet alias $alias_ip_address $alias_subnet_arg
+--- dhcp-4.3.6/client/scripts/openwrt
++++ dhcp-4.3.6/client/scripts/openwrt
+@@ -190,7 +190,7 @@
+   ifconfig $interface $new_ip_address $new_subnet_arg \
+                                       $new_broadcast_arg $mtu_arg
+   set $new_routers
+-  if ping -q -c 1 $1; then
++  if ping -q -c 1 $1 >/dev/null; then
+     if [ x$new_ip_address != x$alias_ip_address ] && \
+                       [ x$alias_ip_address != x ]; then
+       ifconfig $interface:0 $alias_ip_address $alias_subnet_arg

Reply via email to